- Qt 5.15
- Qt Quick Test
- QQuickTest Namespace
- Qt 5.15.18 Reference Documentation

# QQuickTest Namespace

The QQuickTest namespace contains all the functions and macros related to Qt Quick Test. More...

Header: | #include <QtQuickTest>

## Functions

bool | qIsPolishScheduled(const QQuickItem *item)
bool | qWaitForItemPolished(const QQuickItem *item, int timeout = 5000)

## Macros

| QUICK_TEST_MAIN(name)
| QUICK_TEST_MAIN_WITH_SETUP(name, QuickTestSetupClass)

## Detailed Description

See the Introduction to Qt Quick Test for information about how to write Qt Quick unit tests.

To link to the Qt Quick Test C++ library, see Qt Quick Test C++ API.

See also Executing C++ Before QML Tests.

## Function Documentation

### bool QQuickTest::qIsPolishScheduled(const QQuickItem *item)

Returns `true` if updatePolish() has not been called on item since the last call to polish(), otherwise returns `false`.

When assigning values to properties in QML, any layouting the item must do as a result of the assignment might not take effect immediately, but can instead be postponed until the item is polished. For these cases, you can use this function to ensure that the item has been polished before the execution of the test continues. For example:

     QVERIFY(QQuickTest::qIsPolishScheduled(item));
     QVERIFY(QQuickTest::qWaitForItemPolished(item));

Without the call to `qIsPolishScheduled()` above, the call to `qWaitForItemPolished()` might see that no polish was scheduled and therefore pass instantly, assuming that the item had already been polished. This function makes it obvious why an item wasn't polished and allows tests to fail early under such circumstances.

The QML equivalent of this function is isPolishScheduled().

This function was introduced in Qt 5.13.

See also QQuickItem::polish() and QQuickItem::updatePolish().

### bool QQuickTest::qWaitForItemPolished(const QQuickItem *item, int timeout = 5000)

Waits for timeout milliseconds or until updatePolish() has been called on item.

Returns `true` if `updatePolish()` was called on item within timeout milliseconds, otherwise returns `false`.

The QML equivalent of this function is waitForItemPolished().

This function was introduced in Qt 5.13.

See also QQuickItem::polish(), QQuickItem::updatePolish(), and QQuickTest::qIsPolishScheduled().

## Macro Documentation

### QUICK_TEST_MAIN(name)

Sets up the entry point for a Qt Quick Test application. The name argument uniquely identifies this set of tests.

     #include <QtQuickTest>
     QUICK_TEST_MAIN(example)

Note: The macro assumes that your test sources are in the current directory, unless the `QUICK_TEST_SOURCE_DIR` environment variable is set.

See also QUICK_TEST_MAIN_WITH_SETUP() and Running Qt Quick Tests.

### QUICK_TEST_MAIN_WITH_SETUP(name, QuickTestSetupClass)

Sets up the entry point for a Qt Quick Test application. The name argument uniquely identifies this set of tests.

This macro is identical to QUICK_TEST_MAIN(), except that it takes an additional argument QuickTestSetupClass, a pointer to a QObject-derived class. With this class it is possible to define additional setup code to execute before running the QML test.

Note: The macro assumes that your test sources are in the current directory, unless the `QUICK_TEST_SOURCE_DIR` environment variable is set.

The following snippet demonstrates the use of this macro:

     // tst_mytest.cpp
     #include <QtQuickTest>
     #include <QQmlEngine>
     #include <QQmlContext>

     class Setup : public QObject
     {
         Q_OBJECT

     public:
         Setup() {}

     public slots:
         void qmlEngineAvailable(QQmlEngine *engine)
         {
             engine->rootContext()->setContextProperty("myContextProperty", QVariant(true));
         }
     };

     QUICK_TEST_MAIN_WITH_SETUP(mytest, Setup)

     #include "tst_mytest.moc"

See also QUICK_TEST_MAIN() and Running Qt Quick Tests.